#include <stdio.h>
#include <algorithm>
#include <vector>
#include <queue>

using namespace std;

#define INF 0x3f3f3f3f
#define MAX 1024
#define THEBUG(bug...) //printf(bug)

typedef struct aresta
{
	int destino,custo,tempo,escalas;
} aresta;

int N,F;
char tipo[4];
vector<vector<aresta> > g;
aresta D[MAX];

bool operator <(const aresta &a, const aresta &b)
{
	if (tipo[0] == 'P')
	{
		if (a.custo == b.custo)
		{
			if (a.tempo == b.tempo)
				return(a.escalas > b.escalas);
			return(a.tempo > b.tempo);
		}
		return(a.custo > b.custo);
	}
	else // if (tipo[0] == 'E')
	{
		if (a.tempo == b.tempo)
		{
			if (a.custo == b.custo)
				return(a.escalas > b.escalas);
			return(a.custo > b.custo);
		}
		return(a.tempo > b.tempo);
	}
}

int main(void)
{
	int U,V,origem,i;
	aresta e;

	scanf("%d %d %s %d %d",&N,&F,tipo,&U,&V);
	U--; V--;
	g.resize(N);
	for(i = 0; i < F; i++)
	{
		scanf("%d %d %d %d",&origem,&e.destino,&e.custo,&e.tempo);
		origem--; e.destino--;
		g[origem].push_back(e);
	}

	priority_queue<aresta> q;
	aresta d;

	e.custo = e.tempo = e.escalas = INF;
	for(i = 0; i < N; i++)
	{
		e.destino = i;
		D[i] = e;
	}
	
	e.destino = U;
	e.custo = e.tempo = e.escalas = 0;
	D[U] = e;
	q.push(e);
	
	while(!q.empty())
	{
		e = q.top();
		q.pop();

		THEBUG("[%d %d %d %d]\n",e.destino,e.custo,e.tempo,e.escalas);
		
		if (e.destino == V) break;
		// sinal invertido por causa da priority_queue!!!
		if (e < D[e.destino]) continue;

		for(i = 0; i < (int)g[e.destino].size(); i++)
		{
			d.destino = g[e.destino][i].destino;
			d.custo = D[e.destino].custo+g[e.destino][i].custo;
			d.tempo = D[e.destino].tempo+g[e.destino][i].tempo;
			d.escalas = D[e.destino].escalas+1;
			// sinal invertido por causa da priority_queue!!!
			if (D[d.destino] < d)
			{
				D[d.destino] = d;
				q.push(d);
			}
		}
	}
	if (D[V].custo == INF && D[V].tempo == INF)
		printf("-1\n");
	else printf("%d %d %d\n",D[V].custo,D[V].tempo,D[V].escalas-1);
	
	return(0);
}

